#include <ti/devices/msp432p4xx/driverlib/driverlib.h>
#include <ti/devices/msp432p4xx/driverlib/debug.h>
#include <ti/devices/msp432p4xx/driverlib/eusci.h>
/* Standard Includes */
#include <stdint.h>
#include <stdbool.h>
#include "TLC5955.h"

/*Shift 768*4 bits GS data for 4 devices*/
void SendGSData(int *GSdata1,int *GSdata2,int *GSdata3,int *GSdata4)
{
    int k,temp1,temp2;
    /*Send GS data for U4*/
    //  Send MSB=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );// SIN=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

    //  Send 768 bits data; each 16 bits is a channel GSpwm data
    for(k=767;k>=0;k--)
    {
        temp1=1<<(k%16);
        temp2=GSdata4[k/16]&temp1;
        if(temp2==temp1)
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);} //SIN=1
        else
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );} //SIN=0
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }

    /*Send GS data for U3*/
    //  Send MSB=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );// SIN=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

    //  Send 768 bits data; each 16 bits is a channel GSpwm data
    for(k=767;k>=0;k--)
    {
        temp1=1<<(k%16);
        temp2=GSdata3[k/16]&temp1;
        if(temp2==temp1)
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);} //SIN=1
        else
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );} //SIN=0
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }

    /*Send GS data for U2*/
    //  Send MSB=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );// SIN=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

    //  Send 768 bits data; each 16 bits is a channel GSpwm data
    for(k=767;k>=0;k--)
    {
        temp1=1<<(k%16);
        temp2=GSdata2[k/16]&temp1;
        if(temp2==temp1)
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);} //SIN=1
        else
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );} //SIN=0
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }

    /*Send GS data for U1*/
    //  Send MSB=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );// SIN=0
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

    //  Send 768 bits data; each 16 bits is a channel GSpwm data
    for(k=767;k>=0;k--)
    {
        temp1=1<<(k%16);
        temp2=GSdata1[k/16]&temp1;
        if(temp2==temp1)
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);} //SIN=1
        else
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );} //SIN=0
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }

    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-low

    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN7);//XLAT-high
    __delay_cycles(1); //Twh1 XLAT high-level pulse width  1/25M=40ns
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN7 ); //XLAT-low
}

/*Shift 768 bits control data for one device, need to send 4 times for U1 to U4, this code can also be sent like GS data using one Array*/
void SendControlData(
        char LSDVLT1,char ESPWM1,char RFRESH1,char TMGRST1, char DSPRPT1, char *BC_data1,char *MC_data1,char *DC_data1,
        char LSDVLT2,char ESPWM2,char RFRESH2,char TMGRST2, char DSPRPT2, char *BC_data2,char *MC_data2,char *DC_data2,
        char LSDVLT3,char ESPWM3,char RFRESH3,char TMGRST3, char DSPRPT3, char *BC_data3,char *MC_data3,char *DC_data3,
        char LSDVLT4,char ESPWM4,char RFRESH4,char TMGRST4, char DSPRPT4, char *BC_data4,char *MC_data4,char *DC_data4)
{
    int k,k1,k2,k3;
    char temp,temp0,temp1,temp2,temp3,temp4,temp5,temp6;
    char t=0x96;
    /*Send control data for U4*/
    //MSB is 1
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //MSB is 1 SDA
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    // send 0X96
    for(k=767;k>=760;k--)
    {
        temp=1<<(k-760);
        temp0=t&temp;
        if(temp0==temp)
        {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
        }
        else
        {
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
        }
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

    }
    // no control data
    for(k=759;k>=371;k--)
    {
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }
    //LSDVLT is 1 or 0
    if(LSDVLT4==0)
    {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
    else
    {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    //ESPWM is 1 or 0
    if(ESPWM4==0)
    {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
    else
    {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    //RFRESH is 1 or 0
    if(RFRESH4==0)
    {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
    else
    {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    //TMGRST is 1 or 0
    if(TMGRST4==0)
    {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
    else
    {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    //DSPRPT is 1 or 0
    if(DSPRPT4==0)
    {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
    else
    {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
    __delay_cycles(1); //1/25M=40ns
    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    //send BC data BCR[6:0] BCG[6:0] BCB[6:0]
    for (k1=20;k1>=0;k1--)
    {
        temp1=1<<(k1%7);
        temp2=BC_data4[k1/7]&temp1;
        if(temp2==temp1)
        {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
        }
        else
        {
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
        }
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }
    //send MC data MCR[2:0] MCG[2:0] MCB[2:0]
    for (k2=8;k2>=0;k2--)
    {
        temp3=1<<(k2%3);
        temp4=MC_data4[k2/3]&temp3;
        if(temp4==temp3)
        {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
        }
        else
        {
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
        }
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }
    //send DC data
    for (k3=335;k3>=0;k3--)
    {
        temp5=1<<(k3%7);
        temp6=DC_data4[k3/7]&temp5;
        if(temp6==temp5)
        {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
        }
        else
        {
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
        }
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
    }

    /*Send control data for U3*/
        //MSB is 1
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //MSB is 1 SDA
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        // send 0X96
        for(k=767;k>=760;k--)
        {
            temp=1<<(k-760);
            temp0=t&temp;
            if(temp0==temp)
            {
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
            }
            else
            {
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
            }
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

        }
        // no control data
        for(k=759;k>=371;k--)
        {
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        }
        //LSDVLT is 1 or 0
        if(LSDVLT3==0)
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
        else
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        //ESPWM is 1 or 0
        if(ESPWM3==0)
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
        else
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        //RFRESH is 1 or 0
        if(RFRESH3==0)
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
        else
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        //TMGRST is 1 or 0
        if(TMGRST3==0)
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
        else
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        //DSPRPT is 1 or 0
        if(DSPRPT3==0)
        {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
        else
        {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
        __delay_cycles(1); //1/25M=40ns
        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        //send BC data BCR[6:0] BCG[6:0] BCB[6:0]
        for (k1=20;k1>=0;k1--)
        {
            temp1=1<<(k1%7);
            temp2=BC_data3[k1/7]&temp1;
            if(temp2==temp1)
            {
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
            }
            else
            {
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
            }
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        }
        //send MC data MCR[2:0] MCG[2:0] MCB[2:0]
        for (k2=8;k2>=0;k2--)
        {
            temp3=1<<(k2%3);
            temp4=MC_data3[k2/3]&temp3;
            if(temp4==temp3)
            {
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
            }
            else
            {
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
            }
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        }
        //send DC data
        for (k3=335;k3>=0;k3--)
        {
            temp5=1<<(k3%7);
            temp6=DC_data3[k3/7]&temp5;
            if(temp6==temp5)
            {
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
            }
            else
            {
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
            }
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
        }

        /*Send control data for U2*/
            //MSB is 1
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //MSB is 1 SDA
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            // send 0X96
            for(k=767;k>=760;k--)
            {
                temp=1<<(k-760);
                temp0=t&temp;
                if(temp0==temp)
                {
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                }
                else
                {
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
                }
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

            }
            // no control data
            for(k=759;k>=371;k--)
            {
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            }
            //LSDVLT is 1 or 0
            if(LSDVLT2==0)
            {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
            else
            {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            //ESPWM is 1 or 0
            if(ESPWM2==0)
            {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
            else
            {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            //RFRESH is 1 or 0
            if(RFRESH2==0)
            {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
            else
            {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            //TMGRST is 1 or 0
            if(TMGRST2==0)
            {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
            else
            {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            //DSPRPT is 1 or 0
            if(DSPRPT2==0)
            {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
            else
            {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
            GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
            __delay_cycles(1); //1/25M=40ns
            GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            //send BC data BCR[6:0] BCG[6:0] BCB[6:0]
            for (k1=20;k1>=0;k1--)
            {
                temp1=1<<(k1%7);
                temp2=BC_data2[k1/7]&temp1;
                if(temp2==temp1)
                {
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                }
                else
                {
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
                }
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            }
            //send MC data MCR[2:0] MCG[2:0] MCB[2:0]
            for (k2=8;k2>=0;k2--)
            {
                temp3=1<<(k2%3);
                temp4=MC_data2[k2/3]&temp3;
                if(temp4==temp3)
                {
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                }
                else
                {
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
                }
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            }
            //send DC data
            for (k3=335;k3>=0;k3--)
            {
                temp5=1<<(k3%7);
                temp6=DC_data2[k3/7]&temp5;
                if(temp6==temp5)
                {
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                }
                else
                {
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
                }
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
            }

            /*Send control data for U1*/
                //MSB is 1
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //MSB is 1 SDA
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                // send 0X96
                for(k=767;k>=760;k--)
                {
                    temp=1<<(k-760);
                    temp0=t&temp;
                    if(temp0==temp)
                    {
                        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                    }
                    else
                    {
                        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
                    }
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                    __delay_cycles(1); //1/25M=40ns
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high

                }
                // no control data
                for(k=759;k>=371;k--)
                {
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );//SDA 1
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                    __delay_cycles(1); //1/25M=40ns
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                }
                //LSDVLT is 1 or 0
                if(LSDVLT1==0)
                {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
                else
                {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                //ESPWM is 1 or 0
                if(ESPWM1==0)
                {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
                else
                {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                //RFRESH is 1 or 0
                if(RFRESH1==0)
                {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
                else
                {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                //TMGRST is 1 or 0
                if(TMGRST1==0)
                {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
                else
                {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                //DSPRPT is 1 or 0
                if(DSPRPT1==0)
                {GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 );}//SDA 0
                else
                {GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5);}//SDA 1
                GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                __delay_cycles(1); //1/25M=40ns
                GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                //send BC data BCR[6:0] BCG[6:0] BCB[6:0]
                for (k1=20;k1>=0;k1--)
                {
                    temp1=1<<(k1%7);
                    temp2=BC_data1[k1/7]&temp1;
                    if(temp2==temp1)
                    {
                        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                    }
                    else
                    {
                        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=0
                    }
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                    __delay_cycles(1); //1/25M=40ns
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                }
                //send MC data MCR[2:0] MCG[2:0] MCB[2:0]
                for (k2=8;k2>=0;k2--)
                {
                    temp3=1<<(k2%3);
                    temp4=MC_data1[k2/3]&temp3;
                    if(temp4==temp3)
                    {
                        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                    }
                    else
                    {
                        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
                    }
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                    __delay_cycles(1); //1/25M=40ns
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                }
                //send DC data
                for (k3=335;k3>=0;k3--)
                {
                    temp5=1<<(k3%7);
                    temp6=DC_data1[k3/7]&temp5;
                    if(temp6==temp5)
                    {
                        GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN5); //SDA=1
                    }
                    else
                    {
                        GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN5 ); //SDA=0
                    }
                    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-Low
                    __delay_cycles(1); //1/25M=40ns
                    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-high
                }

    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN6);//SCL-low

    GPIO_setOutputHighOnPin(GPIO_PORT_P3,GPIO_PIN7);//XLAT-high
    __delay_cycles(1); //Twh1 XLAT high-level pulse width  1/25M=40ns
    GPIO_setOutputLowOnPin(GPIO_PORT_P3,GPIO_PIN7); //XLAT-low
}
