/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/******************************************************************************
 * MSP432 Empty Project
 *
 * Description: An empty project that uses DriverLib
 *
 *                MSP432P401
 *             ------------------
 *         /|\|                  |
 *          | |                  |
 *          --|RST               |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 * Author: 
 *******************************************************************************/
/* DriverLib Includes */
#include <ti/devices/msp432p4xx/driverlib/driverlib.h>
/* Standard Includes */
#include <stdint.h>
#include <stdbool.h>
#include "TLC5955.h"
#define CPU_F ((double)25000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))
#define  LSDVLT_0   0
#define  LSDVLT_1   1
#define  ESPWM_0   0
#define  ESPWM_1   1
#define  RFRESH_0   0
#define  RFRESH_1   1
#define  TMGRST_0   0
#define  TMGRST_1   1
#define  DSPRPT_0   0
#define  DSPRPT_1   1
unsigned char key_flag;

/*Define the GS data for U1-U4*/
int GSdata1[]=
{
              //16BIT*48CH GS Data for U1
              0xFFFF,0x0000,0x0000,   //U1_OUTR0,U1_OUTG0,U1_OUTB0
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR1,U1_OUTG1,U1_OUTB1
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR2,U1_OUTG2,U1_OUTB2
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR3,U1_OUTG3,U1_OUTB3
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR4,U1_OUTG4,U1_OUTB4
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR5,U1_OUTG5,U1_OUTB5
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR6,U1_OUTG6,U1_OUTB6
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR7,U1_OUTG7,U1_OUTB7
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR8,U1_OUTG8,U1_OUTB8
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR9,U1_OUTG9,U1_OUTB9
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR10,U1_OUTG10,U1_OUTB10
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR11,U1_OUTG11,U1_OUTB11
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR12,U1_OUTG12,U1_OUTB12
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR13,U1_OUTG13,U1_OUTB13
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR14,U1_OUTG14,U1_OUTB14
              0xFFFF,0xFFFF,0xFFFF,   //U1_OUTR15,U1_OUTG15,U1_OUTB15
};
int GSdata2[]=
{
              //16BIT*48CH GS Data for U2
              0x0000,0xFFFF,0x0000,   //U2_OUTR0,U2_OUTG0,U2_OUTB0
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR1,U2_OUTG1,U2_OUTB1
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR2,U2_OUTG2,U2_OUTB2
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR3,U2_OUTG3,U2_OUTB3
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR4,U2_OUTG4,U2_OUTB4
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR5,U2_OUTG5,U2_OUTB5
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR6,U2_OUTG6,U2_OUTB6
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR7,U2_OUTG7,U2_OUTB7
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR8,U2_OUTG8,U2_OUTB8
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR9,U2_OUTG9,U2_OUTB9
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR10,U2_OUTG10,U2_OUTB10
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR11,U2_OUTG11,U2_OUTB11
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR12,U2_OUTG12,U2_OUTB12
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR13,U2_OUTG13,U2_OUTB13
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR14,U2_OUTG14,U2_OUTB14
              0xFFFF,0xFFFF,0xFFFF,   //U2_OUTR15,U2_OUTG15,U2_OUTB15
};
int GSdata3[]=
{
              //16BIT*48CH GS Data for U3
              0x0000,0x0000,0xFFFF,   //U3_OUTR0,U3_OUTG0,U3_OUTB0
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR1,U3_OUTG1,U3_OUTB1
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR2,U3_OUTG2,U3_OUTB2
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR3,U3_OUTG3,U3_OUTB3
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR4,U3_OUTG4,U3_OUTB4
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR5,U3_OUTG5,U3_OUTB5
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR6,U3_OUTG6,U3_OUTB6
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR7,U3_OUTG7,U3_OUTB7
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR8,U3_OUTG8,U3_OUTB8
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR9,U3_OUTG9,U3_OUTB9
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR10,U3_OUTG10,U3_OUTB10
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR11,U3_OUTG11,U3_OUTB11
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR12,U3_OUTG12,U3_OUTB12
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR13,U3_OUTG13,U3_OUTB13
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR14,U3_OUTG14,U3_OUTB14
              0xFFFF,0xFFFF,0xFFFF,   //U3_OUTR15,U3_OUTG15,U3_OUTB15
};
int GSdata4[]=
{
              //16BIT*48CH GS Data for U4
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR0,U4_OUTG0,U4_OUTB0
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR1,U4_OUTG1,U4_OUTB1
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR2,U4_OUTG2,U4_OUTB2
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR3,U4_OUTG3,U4_OUTB3
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR4,U4_OUTG4,U4_OUTB4
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR5,U4_OUTG5,U4_OUTB5
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR6,U4_OUTG6,U4_OUTB6
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR7,U4_OUTG7,U4_OUTB7
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR8,U4_OUTG8,U4_OUTB8
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR9,U4_OUTG9,U4_OUTB9
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR10,U4_OUTG10,U4_OUTB10
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR11,U4_OUTG11,U4_OUTB11
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR12,U4_OUTG12,U4_OUTB12
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR13,U4_OUTG13,U4_OUTB13
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR14,U4_OUTG14,U4_OUTB14
              0xFFFF,0xFFFF,0xFFFF,   //U4_OUTR15,U4_OUTG15,U4_OUTB15
};

//DC MC BC data for U1
char DC_data_1[]=
{
 0x7f,0x7f,0x7f, //GSR0,GSG0,GSB0
 0x7f,0x7f,0x7f, //GSR1,GSG1,GSB1
 0x7f,0x7f,0x7f, //GSR2,GSG2,GSB2
 0x7f,0x7f,0x7f, //GSR3,GSG3,GSB3
 0x7f,0x7f,0x7f, //GSR4,GSG4,GSB4
 0x7f,0x7f,0x7f, //GSR5,GSG5,GSB5
 0x7f,0x7f,0x7f, //GSR6,GSG6,GSB6
 0x7f,0x7f,0x7f, //GSR7,GSG7,GSB7
 0x7f,0x7f,0x7f, //GSR8,GSG8,GSB8
 0x7f,0x7f,0x7f, //GSR9,GSG9,GSB9
 0x7f,0x7f,0x7f, //GSR10,GSG10,GSB10
 0x7f,0x7f,0x7f, //GSR11,GSG11,GSB11
 0x7f,0x7f,0x7f, //GSR12,GSG12,GSB12
 0x7f,0x7f,0x7f, //GSR13,GSG13,GSB13
 0x7f,0x7f,0x7f, //GSR14,GSG14,GSB14
 0x7f,0x7f,0x7f //GSR15,GSG15,GSB15
};
char MC_data_1[]={0x03,0x03,0x03}; //MCR[2:0],MCG[2:0],MCB[2:0]
char BC_data_1[]={0x0f,0x0f,0x0f}; //BCR[6:0],BCG[6:0],BCB[6:0]

//DC MC BC data for U2
char DC_data_2[]=
{
 0x7f,0x7f,0x7f, //GSR0,GSG0,GSB0
 0x7f,0x7f,0x7f, //GSR1,GSG1,GSB1
 0x7f,0x7f,0x7f, //GSR2,GSG2,GSB2
 0x7f,0x7f,0x7f, //GSR3,GSG3,GSB3
 0x7f,0x7f,0x7f, //GSR4,GSG4,GSB4
 0x7f,0x7f,0x7f, //GSR5,GSG5,GSB5
 0x7f,0x7f,0x7f, //GSR6,GSG6,GSB6
 0x7f,0x7f,0x7f, //GSR7,GSG7,GSB7
 0x7f,0x7f,0x7f, //GSR8,GSG8,GSB8
 0x7f,0x7f,0x7f, //GSR9,GSG9,GSB9
 0x7f,0x7f,0x7f, //GSR10,GSG10,GSB10
 0x7f,0x7f,0x7f, //GSR11,GSG11,GSB11
 0x7f,0x7f,0x7f, //GSR12,GSG12,GSB12
 0x7f,0x7f,0x7f, //GSR13,GSG13,GSB13
 0x7f,0x7f,0x7f, //GSR14,GSG14,GSB14
 0x7f,0x7f,0x7f //GSR15,GSG15,GSB15
};
char MC_data_2[]={0x03,0x03,0x03}; //MCR[2:0],MCG[2:0],MCB[2:0]
char BC_data_2[]={0x1f,0x1f,0x1f}; //BCR[6:0],BCG[6:0],BCB[6:0]

//DC MC BC data for U3
char DC_data_3[]=
{
 0x7f,0x7f,0x7f, //GSR0,GSG0,GSB0
 0x7f,0x7f,0x7f, //GSR1,GSG1,GSB1
 0x7f,0x7f,0x7f, //GSR2,GSG2,GSB2
 0x7f,0x7f,0x7f, //GSR3,GSG3,GSB3
 0x7f,0x7f,0x7f, //GSR4,GSG4,GSB4
 0x7f,0x7f,0x7f, //GSR5,GSG5,GSB5
 0x7f,0x7f,0x7f, //GSR6,GSG6,GSB6
 0x7f,0x7f,0x7f, //GSR7,GSG7,GSB7
 0x7f,0x7f,0x7f, //GSR8,GSG8,GSB8
 0x7f,0x7f,0x7f, //GSR9,GSG9,GSB9
 0x7f,0x7f,0x7f, //GSR10,GSG10,GSB10
 0x7f,0x7f,0x7f, //GSR11,GSG11,GSB11
 0x7f,0x7f,0x7f, //GSR12,GSG12,GSB12
 0x7f,0x7f,0x7f, //GSR13,GSG13,GSB13
 0x7f,0x7f,0x7f, //GSR14,GSG14,GSB14
 0x7f,0x7f,0x7f //GSR15,GSG15,GSB15
};
char MC_data_3[]={0x03,0x03,0x03}; //MCR[2:0],MCG[2:0],MCB[2:0]
char BC_data_3[]={0x2f,0x2f,0x2f}; //BCR[6:0],BCG[6:0],BCB[6:0]

//DC MC BC data for U4
char DC_data_4[]=
{
 0x7f,0x7f,0x7f, //GSR0,GSG0,GSB0
 0x7f,0x7f,0x7f, //GSR1,GSG1,GSB1
 0x7f,0x7f,0x7f, //GSR2,GSG2,GSB2
 0x7f,0x7f,0x7f, //GSR3,GSG3,GSB3
 0x7f,0x7f,0x7f, //GSR4,GSG4,GSB4
 0x7f,0x7f,0x7f, //GSR5,GSG5,GSB5
 0x7f,0x7f,0x7f, //GSR6,GSG6,GSB6
 0x7f,0x7f,0x7f, //GSR7,GSG7,GSB7
 0x7f,0x7f,0x7f, //GSR8,GSG8,GSB8
 0x7f,0x7f,0x7f, //GSR9,GSG9,GSB9
 0x7f,0x7f,0x7f, //GSR10,GSG10,GSB10
 0x7f,0x7f,0x7f, //GSR11,GSG11,GSB11
 0x7f,0x7f,0x7f, //GSR12,GSG12,GSB12
 0x7f,0x7f,0x7f, //GSR13,GSG13,GSB13
 0x7f,0x7f,0x7f, //GSR14,GSG14,GSB14
 0x7f,0x7f,0x7f //GSR15,GSG15,GSB15
};
char MC_data_4[]={0x03,0x03,0x03}; //MCR[2:0],MCG[2:0],MCB[2:0]
char BC_data_4[]={0x3f,0x3f,0x3f}; //BCR[6:0],BCG[6:0],BCB[6:0]

int main(void)
{
    /* Stop Watchdog */
    MAP_WDT_A_holdTimer();
    /* Setting the DCO Frequency to a non-standard 8.33MHz */
    // MAP_CS_setDCOFrequency(8330000);

    /* Initializing the clock source as follows:
     *      MCLK = MODOSC/4 = 6MHz
     *      ACLK = REFO/2 = 16kHz
     *      HSMCLK = DCO/2 = 1.5Mhz
     *      SMCLK = DCO/4 = 750kHz
     *      BCLK  = REFO = 32kHz
     */
    MAP_CS_initClockSignal(CS_MCLK, CS_MODOSC_SELECT, CS_CLOCK_DIVIDER_1);  //MODOSC:Internal low-power oscillator with 25-MHz typical frequency


    GPIO_setAsOutputPin(GPIO_PORT_P3, GPIO_PIN5|GPIO_PIN6|GPIO_PIN7); //P3.5 SIN P3.6 SCLK P3.7 XLAT
    GPIO_setOutputLowOnPin(GPIO_PORT_P3, GPIO_PIN5|GPIO_PIN6|GPIO_PIN7);
    GPIO_setAsInputPin(GPIO_PORT_P5, GPIO_PIN2);   //P5.2 SOUT
    GPIO_setAsPeripheralModuleFunctionOutputPin(GPIO_PORT_P4,GPIO_PIN2|GPIO_PIN3,GPIO_PRIMARY_MODULE_FUNCTION);// P4.3->MCLK   for GSCLK

    /*Send control data first*/
    SendControlData(
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_1,MC_data_1,DC_data_1,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_2,MC_data_2,DC_data_2,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_3,MC_data_3,DC_data_3,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_4,MC_data_4,DC_data_4);


    /*Send twice for the control data to update*/
    SendControlData(
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_1,MC_data_1,DC_data_1,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_2,MC_data_2,DC_data_2,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_3,MC_data_3,DC_data_3,
            LSDVLT_1,ESPWM_0,RFRESH_1,TMGRST_1,DSPRPT_1,BC_data_4,MC_data_4,DC_data_4);

    /*Send GS Data*/
    SendGSData(GSdata1,GSdata2,GSdata3,GSdata4);

}
